Attribute VB_Name = "Main"
Option Explicit
    
Public Sub RunGlobalConfig()
  Dim fso As New Scripting.FileSystemObject
  Dim sConfig$: sConfig = ConceptConfigPath
  If Not fso.FileExists(sConfig) Then
    Call UserInteraction.ShowMessage(EM_MISSING_CONFIG, sConfig)
    Exit Sub
  End If
  
  Dim oShell As New Shell32.Shell
  Call oShell.Open(sConfig)
End Sub

Public Sub RunGenerateWrapper()
  Dim sSource$: sSource = UserInteraction.PromptFileFilter(ThisWorkbook.Path & "\", " Python", "*.py", " ")
  If sSource = vbNullString Then _
    Exit Sub
    
  Dim fso As New Scripting.FileSystemObject
  Dim sDestination$: sDestination = ThisWorkbook.Path & "\" & fso.GetBaseName(sSource) & ".bas"
   
  Dim sResult$: sResult = CreatePythonWrapper(sSource, sDestination)
  If sResult <> vbNullString Then _
    Call UserInteraction.ShowMessage(IM_WRAPPER_OK, sResult)
End Sub

' ========
Sub BasicTest()
  Dim iPython As API_Python: Set iPython = AccessPython
'  Call iPython.Py.Exec("print(1)")
  Debug.Print Py_double_sum(1, 2)
  'Call iPython.UnloadDLL
 ' Call iPython.KillServer
 ' Call iPython.ResetCache
'  Dim a
'  a = iPython.Py.Bool(True)
'  Call iPython.KillServer
  '  Debug.Print Py_hello("World")
 ' Call AccessPython.KillServer
'  Call iPython.Py.ImportModule("test", 2)
 ' Call AccessPython.ResetCache
End Sub

Public Function Py_hello(pyArg_name)
    Dim iPython As API_Python: Set iPython = AccessPython
    On Error GoTo FAILED_CALL
    Py_hello = iPython.CallFunction("standalone", "hello", Array(pyArg_name))
    On Error GoTo 0
    Exit Function
FAILED_CALL:
    Py_hello = Err.Description
End Function

Public Function Py_double_sum(pyArg_x, pyArg_y)
    Dim iPython As API_Python: Set iPython = AccessPython
    On Error GoTo FAILED_CALL
    Py_double_sum = iPython.CallFunction("standalone", "double_sum", Array(pyArg_x, pyArg_y))
    On Error GoTo 0
    Exit Function
FAILED_CALL:
    Py_double_sum = Err.Description
End Function

Sub TestPythonCall()
  Dim theTimer As New API_Timer
  Call Py_double_sum(1, 2)
  
  Call theTimer.Start
  Dim n&
  Dim nTest&
  For n = 1 To 1000 Step 1
    nTest = Py_double_sum(n, n + 1)
  Next n
  
  Debug.Print "Python test: " & theTimer.TimeStr
End Sub
