class VBAWriter:
    ''' Class for creating VBA code '''
    def __init__(self, out_file):
        self._output = out_file
        self._indent = 0

    def start_block(self, block_header):
        self.line(block_header)
        self._indent += 1

    def end_block(self, block_footer):
        self._indent -= 1
        self.line(block_footer)

    def label(self, label_name):
        indent = self._indent
        self._indent = 0
        self.line(label_name + ':')
        self._indent = indent

    def line(self, text_line):
        self._output.write(('  ' * self._indent) + text_line + '\n')
