#pragma once

namespace vbatopy {

class Server {
public:
	// Dispatcher interface is provided by server process through COM CoCreateInstance
	IDispatch* dispatcher{ nullptr };
	GUID clsid{};

private:
	HANDLE jobHandle{};
	HANDLE pyProcess{};
	HANDLE pyThread{};

	bool showConsole{ false };
	std::string execCommand{};

	Server();
	~Server();

public:
	static Server& Instance();

	void Setup(std::string command, bool showConsole_);
	[[nodiscard]] bool CheckStatus() const;
	void Start();
	void Kill();
	void ForceKill();

private:
	void ReleaseDispatch();
	void ReleaseKillerJob();

	void CreateInternalProcess();
	void CreateKillerJob();
	void ActivateDispatcher();

	void SubstituteMacro(std::string& path) const;
};

} // namespace vbatopy