#pragma once

namespace vbatopy::utils {

void ToVariant(const char* str, VARIANT* var);
std::string GUIDToStr(GUID guid);

std::string GetLastErrorMessage();

struct AutoCloseHandle {
	HANDLE handle{ nullptr };

	explicit AutoCloseHandle(HANDLE handle) {
		this->handle = handle;
	}
	~AutoCloseHandle() {
		if (handle != nullptr && handle != INVALID_HANDLE_VALUE) {
			CloseHandle(handle);
		}
	}

	HANDLE Release() {
		HANDLE res = handle;
		handle = nullptr;
		return res;
	}
};

void ApplyPythonEscaping(std::string& target);
std::string GeneratePythonCommand(std::string pythonExe, std::string sources, GUID clsid);

} // namespace vbatopy::utils